﻿Type=Activity
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true	
	#IncludeTitle: false	
#End Region

#Extends: android.support.v7.app.AppCompatActivity

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private edtMessage As EditText
	Private edtSendTo As EditText
	Dim fbdl As FirebaseDynamicLinks
	Dim invite As AppInviteInvitationBuilder
	Dim cs As CSBuilder
End Sub

Sub Activity_Create(FirstTime As Boolean)

	Activity.LoadLayout("Layout2")
	
	edtSendTo.Text = "mick@company.com"
	edtMessage.Text = "This is a testmessage..."
	
End Sub
Sub Activity_Resume
End Sub
Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub btnSend_Click
	Log("#-PrepMessage.btnSend_Click")
	
	'├
	'├ TODO: Create and send "Dynamic link" via intent
	'├

	' ─────────────────
	' This needs to be translated to a B4A Intent "AppInviteInvitation"	
	' ─────────────────
	' Info -->	https://github.com/firebase/quickstart-android/blob/master/invites/app/src/main/java/com/google/firebase/quickstart/invites/MainActivity.java#L119-L127
	'
	'				    // [START on_invite_clicked]
	'				    Private void onInviteClicked() {
	'				        Intent intent = new AppInviteInvitation.IntentBuilder(getString(R.string.invitation_title))
	'				                .setMessage(getString(R.string.invitation_message))
	'				                .setDeepLink(Uri.parse(getString(R.string.invitation_deep_link)))
	'				                .setCustomImage(Uri.parse(getString(R.string.invitation_custom_image)))
	'				                .setCallToActionText(getString(R.string.invitation_cta))
	'				                .build();
	'				        startActivityForResult(intent, REQUEST_INVITE);
	'				    }
	'				    // [END on_invite_clicked]
	' ─────────────────	
	

	' 
	fbdl.Initialize("fbdl") 
	fbdl.DynamicLinkDomain = "xxxx.app.goo.gl" ' "t62hm.app.goo.gl"
	fbdl.setSocialMetaTagParameters("description", "imageUrl", "title")
	'fbdl.Link = "https://fbdl.basic4android.de/secure/test/"
	fbdl.Link = "https://fbdl.basic4android.de/secure/test/"
	
	' Seems that we are not allowed to call buildShortDynamicLink to build an shorturl.
	' We need to go over the Invitatinbuilder i guess....
	' we cget an Exception = Forbidden at some time after calling this Method
	'fbdl.buildShortDynamicLink
	
	Dim dynlink As DynamicLink = fbdl.BuildDynamicLink
	Log($"#-  x67, strDynamicLink=${dynlink.Parameters}"$)
	For Each key As String In dynlink.Parameters.Keys
		Log($"#-  x67a, ${key}=${dynlink.Parameters.Get(key)}"$)		
	Next
	' Result from log: #-  x67, strDynamicLink=com.google.firebase.dynamiclinks.DynamicLink@55a21d2

	

	invite.Initialize("Invite","Einladung")
	invite.DeepLink = dynlink.UriStr
	invite.Message = cs.Initialize.Color(0xFF01FF20).Size(20).Append("Einladung AppInvite :-)").PopAll
	invite.EmailHtmlContent = $"This app you NEED: bla bla bla<br>Check this: <a href="%%APPINVITE_LINK_PLACEHOLDER%%">AppInvite</a><br><br>Greetings ;-)"$
	' When using EmailHtmlContent then you should not use CalltoActionText!
	'invite.CallToActionText = cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF01FF20).Size(40).Append(Chr(0xF17B) & " Einladung " & Chr(0xF17B)).PopAll
	'Invite_onInvite([888939569991-41fae34e-f62d-4b6c-a7be-947dc90279cb])
	invite.EmailSubject = "B4A AppInvite rocks!"
	'invite.AdditionalReferralParameters = CreateMap("FredoSpecialParameter":"HUHU! :D")
	invite.build
	ToastMessageShow("Message sent", True)

End Sub
Sub Invite_onInvite(invites As List)
	Log($"Invite_onInvite(${invites})"$)
	'http://invite.basic4android.de/?action=addinv&invcode=888939569991-41fae34e-f62d-4b6c-a7be-947dc90279cb&deviceID=ffxxtt&invval=Hellp%20world!!!!
	If invites.IsInitialized Then
		If invites.Size > 0 Then
			For i = 0 To invites.Size -1 
				Dim code As String = invites.Get(i)
				
				Dim jgen As JSONGenerator
				jgen.Initialize(CreateMap("Description": "Bla bla bla", "PromoCode": "xyz","PromoID":15))
				Dim j As HttpJob
				j.Initialize("",Me)
				j.Download2("https://urlinthecloud",Array As String("action","addinv","invcode",code,"deviceID",Starter.DeviceID,"invval",jgen.ToString))
				Wait For (j) JobDone(job As HttpJob)
				If job.Success Then
					Log(job.GetString)
				Else
					Log(job.ErrorMessage)
				End If
				job.Release

			Next
		End If
	End If
End Sub
Sub ParseUri(s As String) As Object
    Dim r As Reflector
    Return r.RunStaticMethod("android.net.Uri", "parse", Array As Object(s), Array As String("java.lang.String"))
End Sub


Sub fbdl_onComplete(shortlinktask As Object)
	Log("#-fbdl_onComplete")
	Dim task As JavaObject = shortlinktask
	Do While task.RunMethod("isComplete", Null) = False
		Log($"#-  x67b, sleep(100)"$)
		Sleep(100)
	Loop
	Log($"#-  x67c, task beendet"$)
	Log("Reloaded")
	'Log("#-  x44, previewLink=" & previewLink)
	'Log("#-  x45, shortLink=" & shortLink)
	Log(fbdl.getresult(shortlinktask))
End Sub
Sub fbdl_onFailure()
	Log("#-fbdl_onFailure")
	Log(LastException)
	Log("#-fbdl_onFailure")
End Sub
